package markov;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.stream.Stream;

public class Sentence implements Iterable<Decission>, Serializable {
    private final Collection<Decission> decissions = new ArrayList<>();
    private final Data data;

    public Sentence(Data data) {
        this.data = data;
    }

    public Data getData() {
        return data;
    }

    public void add(Decission decission) {
        this.decissions.add(decission);
    }

    public double propability() {
        return asStream().mapToDouble(Decission::getPropability)
                .reduce((d1, d2) -> d1 * d2)
                .getAsDouble();
    }

    public Stream<Decission> asStream() {
        return decissions.stream();
    }

    @Override
    public Iterator<Decission> iterator() {
        return decissions.iterator();
    }
}
