package markov;

import markov.stuff.CountMap;
import markov.stuff.SimpleCountMap;
import markov.stuff.Utils;

import java.nio.ByteBuffer;
import java.util.Base64;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ShortenerByteHUffmanTrainerImpl extends ShortenerSimpleImpl {

    private final CountMap<Integer> intsMap = new SimpleCountMap<>();
    private final CountMap<Byte> byteMap = new SimpleCountMap<>();

    public CountMap<Integer> getIntsMap() {
        return intsMap;
    }

    public CountMap<Byte> getByteMap() {
        return byteMap;
    }

    public ShortenerByteHUffmanTrainerImpl(Data data) {
        super(data);
        String prefix = "init trainer for " + data.getPrefixLength() + ": ";
//        for (int i = 0; i < Integer.MAX_VALUE; i++) {
//            intsMap.count(i);
//            Utils.maybePrintPercentages(prefix, i, Integer.MAX_VALUE);
//        }
//        for (int i = 0; i < Byte.MAX_VALUE; i++) {
//            byteMap.count((byte) i);
//        }
    }

    String fromInts(Stream<Integer> ints) {
        List<Byte> bl = ints.flatMap(i -> {
            intsMap.count(i);
            if (i < 128) {
                return Stream.of((byte) (i | 0b10000000));
            } else {
                Stream.Builder<Byte> builder = Stream.<Byte>builder();
                for (byte b : Utils.toByteArray(i)) {
                    builder.add(b);
                }
                return builder.build();
            }
        }).collect(Collectors.toList());
        ByteBuffer bb = ByteBuffer.allocate(bl.size());
        for (Byte b : bl) {
            bb.put(b);
            byteMap.count(b);
        }
        bb.rewind();
        return Base64.getEncoder().encodeToString(bb.array());
    }

}