package markov.huffman;

import markov.stuff.CountMap;

import java.io.Serializable;
import java.util.Collections;
import java.util.Map;

public class HuffmanStore<Subtype extends Serializable> implements Serializable {

    private static final long serialVersionUID = 21475544004070999L;

    private final Map<Integer, CountMap<Subtype>> internal;

    public HuffmanStore(Map<Integer, CountMap<Subtype>> internal) {
        this.internal = internal;
    }

    public CountMap<Subtype> get(int i) {
        return internal.get(i);
    }

    public Map<Integer, CountMap<Subtype>> getInternal() {
        return Collections.unmodifiableMap(internal);
    }
}
