package markov.stuff;

import markov.Data;
import markov.Lookup;
import markov.Prefix;
import markov.Token;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;

public class Inspector {

    public static void printDataHashStats(Map<Integer, Data> dataMaps) throws NoSuchFieldException, IllegalAccessException {
        for (Map.Entry<Integer, Data> e : dataMaps.entrySet()) {
            System.out.println(String.format("map for prefixLength: %d:", e.getKey()));
            System.out.println("Hash clash print: ");
            Map<Integer, Integer> hashClashes =
                    MapClashInspector.getHashClashDistribution(extractMap(e.getValue()));
            printClashes(hashClashes);

            System.out.println("Bucket entry clash print: ");
            Map<Integer, Integer> bucketClashes =
                    MapClashInspector.getBucketClashDistribution(extractMap(e.getValue()));
            printClashes(bucketClashes);
        }

    }

    public static HashMap<Prefix, Lookup> extractMap(Data data) throws NoSuchFieldException, IllegalAccessException {
        Field nextNodeField = data.getClass().getDeclaredField("data");
        nextNodeField.setAccessible(true);
        return (HashMap) nextNodeField.get(data);
    }


    private static void printClashes(
            Map<Integer, Integer> clashes) {
        for (Map.Entry<Integer, Integer> e : clashes.entrySet()) {
            System.out.println(e.getKey() + ": " + e.getValue());
        }
    }
}
