package markov;

import org.junit.jupiter.api.Test;

import java.util.Arrays;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotEquals;

public class TokenTests {

      @Test
    public void testTokenEquals() {
        Token a = new Token("a");
        Token aa = new Token("a");
        Token b = new Token("b");
        assertEquals(a, aa);
        assertNotEquals(a, b);
        assertNotEquals(aa, b);
    }

    @Test
    public void testPrefixEquals() {
        Prefix a = new Prefix(new Token[]{new Token("a")});
        Prefix aa = new Prefix(new Token[]{new Token("a")});
        Prefix aaa = new Prefix(Arrays.asList(new Token("a")));
        Prefix b = new Prefix(new Token[]{new Token("b")});
        assertEquals(a, aa);
        assertEquals(aa, aaa);
        assertEquals(a, aaa);
        assertNotEquals(a, b);
        assertNotEquals(aa, b);
        assertNotEquals(aaa, b);
    }

}
